
/***** Program pro MCU ATmega16, zadvac jednotka, Ing. Marin Zl *****/

#include <avr/io.h>
#include <compat/deprecated.h>
#include <util/delay.h>

char cti_klavesnici(void)	// funkce pro ten znaku z klvesnice
{
	char sloupec = 0xFF;	// promnn pro manipulaci natenho sloupce
	char znak = 0xFF;

	// aktivace sloupce 3 - #
	sbi(PORTB,5);
	sbi(PORTB,4);
	cbi(PORTB,6);

	_delay_ms(1);

	sloupec = PINB & 0x0F;	// vymaskovn pro ten dku
	switch(sloupec)			// piazen znaku na zklad vyhodnocen dk
	{
		case 0b00001101: znak = 0x03; goto SKOK; break;		// zmknuto tlatko 3
		case 0b00000111: znak = 0x06; goto SKOK; break;		// zmknuto tlatko 6
		case 0b00001011: znak = 0x09; goto SKOK; break;		// zmknuto tlatko 9
		case 0b00001110: znak = 0x0F; goto SKOK; break;		// zmknuto tlatko #
		default: znak = 0xFF; sloupec = 0xFF; 				// nen zmknut dn tlatko
	}

	// aktivace sloupce 2 - 0
	sbi(PORTB,5);
	cbi(PORTB,4);
	sbi(PORTB,6);

	_delay_ms(1);
	
	sloupec = PINB & 0x0F;	// vymaskovn pro ten dku	
	switch(sloupec)			// piazen znaku na zklad vyhodnocen dk
	{
		case 0b00001101: znak = 0x02; goto SKOK; break;		// zmknuto tlatko 2
		case 0b00000111: znak = 0x05; goto SKOK; break;		// zmknuto tlatko 5
		case 0b00001011: znak = 0x08; goto SKOK; break;		// zmknuto tlatko 8
		case 0b00001110: znak = 0x00; goto SKOK; break; 	// zmknuto tlatko 0
		default: znak = 0xFF; sloupec = 0xFF; 				// nen zmknut dn tlatko
	}

	// aktivace sloupce 1 - *
	cbi(PORTB,5);
	sbi(PORTB,4);
	sbi(PORTB,6);

	_delay_ms(1);

	sloupec = PINB & 0x0F;	// vymaskovn pro ten dku
	switch(sloupec)			// piazen znaku na zklad vyhodnocen dk
	{
		case 0b00001101: znak = 0x01; goto SKOK; break;		// zmknuto tlatko 1
		case 0b00000111: znak = 0x04; goto SKOK; break;		// zmknuto tlatko 4
		case 0b00001011: znak = 0x07; goto SKOK; break;		// zmknuto tlatko 7
		case 0b00001110: znak = 0x0E; goto SKOK; break; 	// zmknuto tlatko *
		default: znak = 0xFF; sloupec = 0xFF; 				// nen zmknut dn tlatko
	}

SKOK: asm("NOP");
	
	return znak;
}

void zapis_displej(char pozice, char znak)	// funkce pro zpis na pomocn displej
{
	char znak_b3 = 0;
	char znak_b2 = 0;
	char znak_b1 = 0;
	char znak_b0 = 0;

	// rozklad promnn znak na jednotliv bity
	znak_b3 = (znak & 0b00001000) >> 3;
	znak_b2 = (znak & 0b00000100) >> 2;
	znak_b1 = (znak & 0b00000010) >> 1;
	znak_b0 = (znak & 0b00000001);

	switch(pozice)	// vymazn pedchozho zobrazenho znaku na displeji
	{
		case 100: PORTA = PORTA & 0xF0; break;
		case 10:  PORTA = PORTA & 0x0F; break;
		case 1:   PORTC = PORTC & 0x0F; break;
		case 101: PORTC = PORTC & 0xF0; break; 
	}

	switch(pozice)	// zapsn novho znaku bit po bitu, v zvislosti na jednotlivch pinech pipojenho aie displeje
	{
		case 100: PORTA = PORTA | (znak_b3 << 1) | (znak_b2 << 3) | (znak_b1 << 2) | (znak_b0 << 0); break;
		case 10:  PORTA = PORTA | (znak_b3 << 5) | (znak_b2 << 7) | (znak_b1 << 6) | (znak_b0 << 4); break;
		case 1:   PORTC = PORTC | (znak_b3 << 6) | (znak_b2 << 4) | (znak_b1 << 5) | (znak_b0 << 7); break;
		case 101: PORTC = PORTC | (znak_b3 << 2) | (znak_b2 << 0) | (znak_b1 << 1) | (znak_b0 << 3); break; 
	}


}

void zapis_vysilac(char znak)	// funkce pro zpis na vysla MTX1  
{
	char znak_b3 = 0;
	char znak_b2 = 0;
	char znak_b1 = 0;
	char znak_b0 = 0;

	// rozklad promnn znak na jednotliv bity
	znak_b3 = (znak & 0b00001000) >> 3;
	znak_b2 = (znak & 0b00000100) >> 2;
	znak_b1 = (znak & 0b00000010) >> 1;
	znak_b0 = (znak & 0b00000001);

	// vynulovn pedchozho stavu na vyslai
	PORTD = PORTD & 0b11100000;
	
	// zapsn znaku bit po bitu, v zvislosti na jednotlivch pinech vyslae
	PORTD = PORTD | (znak_b3 << 0) | (znak_b2 << 1) | (znak_b1 << 3) | (znak_b0 << 4);

	// zpis "adresy"
	if 		(((PIND & 0b01100000) >> 5) == 0x00)	{PORTD = PORTD | 0b01000000;}
	else if (((PIND & 0b01100000) >> 5) == 0x03)	{PORTD = PORTD | 0b01000000;}
	else 	{PORTD = PORTD ^ 0b01100000;}

}

int main(void)	// hlavn funkce
{
	char znak = 0x0F;
	char predchozi_znak = 0;
	char mod_desetina = 0;
	char tabulka_hodnot[3] = {0x0F,0x0F,0x0F};	// buffer pro rotaci znaku a zobrazovani "zprava"
	
	// nastaven vstupn - vstupnch pin
	PORTA=0xFF;	// pozice na disleji jsou prazdne
	DDRA=0xFF;	// 0-3 vstup na DL100, 4-7 vstup na DL10
	PORTB=0x00;
	DDRB=0xF0;	// 0-3 vstup pro ten sloupc klvesnice, 4-6 vstup pro aktivaci sloupc	
	PORTC=0xFF;	// pozice na disleji jsou prazdne
	DDRC=0xFF;	// 0-3 vstup na DL0,1, 4-7 vstup na DL1
	PORTD=0x00;
	DDRD=0xFB;	// 0,1 - vstup na adresaci, 3-6 vstup BCD na vys., 7 - vstup na destinnou rku

	sbi(PORTD,7); // zhasne desetinnou rku

	while(1)
    {	
		znak = cti_klavesnici();	// teme znak z klvesnice	

		if (znak != predchozi_znak  && znak != 0xFF)	// nerovn se pedchozmu znaku a znak nen "przdn" tzn. byl zadn klavesnic
		{	
			zapis_vysilac(znak);	// odesln znaku na zobrazovac jednotku	
			
			// zpracovn a zpis na pomocn displej
			if (znak == 0x0F)	//zmknuto resetovac tlatko na klvesnici
			{
				// zpis przdn hodnoty na vechny pozici displeje
				zapis_displej(100, znak);
				zapis_displej(10, znak);
				zapis_displej(1, znak);
				zapis_displej(101, znak);

				sbi(PORTD,7);		// zhasne desetinnou rku
				mod_desetina = 0;	// zrume desetinn md

				// vymaeme tabulku hodnot
				tabulka_hodnot[2] = 0x0F;
				tabulka_hodnot[1] = 0x0F;
				tabulka_hodnot[0] = 0x0F;

			}	
			else if (znak == 0x0E)	// zmknuto tlatko pro pesun na desetinnou pozici
			{
				cbi(PORTD,7);		// rozsvt desetinnou rku
				mod_desetina = 1;
			}		
			else if (znak != 0xFF)	// zmknuto seln tlatko na klvesnici
			{
				if(mod_desetina == 0)	// nejsme v desetinnm mdu
				{
					// posun sla
					tabulka_hodnot[2] = tabulka_hodnot[1];	// druh znak se pesune na tet pozici
					tabulka_hodnot[1] = tabulka_hodnot[0];	// prvn znak se pesune druh pozici
					tabulka_hodnot[0] = znak;				// aktuln se pesune na prvn pozici

					// zpis sla na displej
					zapis_displej(100, tabulka_hodnot[2]);
					zapis_displej(10, tabulka_hodnot[1]);
					zapis_displej(1, tabulka_hodnot[0]);
				}
				if (mod_desetina == 1)	// jsme v desetinnm mdu
				{
					zapis_displej(101, znak);
				}
			}
			_delay_ms(800);	// ekej, dokud neprobhne odesln znaku
	
		}
		
		predchozi_znak = znak;	// uloen pedchozho znaku pro porovnn
	}	
	return 0;
}
